﻿using System;
using System.Collections.Generic;
using System.Text;

namespace IASA.Demo.BusinessModel
{
    public class Address
    {
        public Address()
        {
        }

        public string StreetAddress1
        {
            get; set; 
        }

        public string StreetAddress2
        {
            get;
            set; 
        }

        public string City
        {
            get;
            set; 
        }

        public string State
        {
            get;
            set; 
        }

        public string PostalCode
        {
            get;
            set; 
        }

        public ISalesTax SalesTaxStrategy
        {
            get
            {
                return GetSalesTaxStrategy();
            }
        }

        private ISalesTax GetSalesTaxStrategy()
        {

            ISalesTax salesTaxStrategy;

            switch (this.State)
            {
                case "NJ":
                    salesTaxStrategy = new NJSalesTax();
                    break;
                case "PA":
                    salesTaxStrategy = new PASalesTax();
                    break;
                case "NY":
                default:
                    salesTaxStrategy = new NYSalesTax();
                    break;
            }

            return salesTaxStrategy;
        }
    }
}
