﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace IASA.Demo.BusinessModel
{
    public class Customer
    {
        public Customer()
        {
        }

        public Guid Id
        {
            get;
            set;
        }

        public string Name
        {
            get;
            set;
        }

        public Address ShipToAddress
        {
            get;
            set;
        }

        public Address BillToAddress
        {
            get;
            set;
        }

        public Order CurentOrder
        {
            get;
            set;
        }

        public IList<Order> OrderHistory
        {
            get;
            set;
        }
    
        public int GetNumberOfOpenOrders()
        {
            int numberOfOpenItems = 0;

            foreach (Order item in this.OrderHistory)
            {
                if (item.IsOpen)
                    numberOfOpenItems++;
            }

            return numberOfOpenItems;
        }

        public double CalculateCurrentOrder()
        {
            double currentOrderCost = 0;

            currentOrderCost = this.CurentOrder.CalculateOrderCost();

            return currentOrderCost;
        }

        public double CalculateOrderBalance()
        {
            double orderBalance = 0;

            foreach (Order item in this.OrderHistory)
            {
                if (item.IsOpen)
                    orderBalance+=item.CalculateOrderCost();
            }

            return orderBalance;
        }
    }
}
