﻿using System;
using System.Collections.Generic;
using System.Text;

namespace IASA.Demo.BusinessModel
{
    public class Order
    {

        public Order()
        {
        }
        
        public Guid Id
        {
            get; set; 
        }

        public DateTime OrderProcessDate
        {
            get; set; 
        }

        public bool IsOpen
        {
            get { return !this.IsComplete; }
        }


        public bool IsComplete
        {
            get;
            set;
        }

        public bool IsOrderValid
        {
            get
            {
                return this._orderDetails.Count > 0;
            }
        }

        private IList<OrderDetail> _orderDetails = new List<OrderDetail>();
        public System.Collections.Generic.IList<OrderDetail> OrderDetails
        {
            get
            {
                return _orderDetails;
            }
        }

        public void AddOrderDetail(int numberOfItems, Product product)
        {
            OrderDetail detail = new OrderDetail { NumberOfItems = numberOfItems, Product = product };
            this._orderDetails.Add(detail);
        }


        public double CalculateOrderCost()
        {
            double orderCost = 0;

            foreach (OrderDetail item in this._orderDetails)
            {
                orderCost += item.CalculateItemCost();
            }

            return orderCost;
        }
    }
}
