﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Unity;
using Microsoft.Practices.Unity.Configuration;
using Microsoft.Practices.Unity.StaticFactory;
using IASA.Demo.CreditCardProvider;

namespace IASA.Demo.BusinessService
{
    public class CreditCardProvider
    {
        private IUnityContainer _providerContainer;

        private CreditCardProvider()
        {
            this._providerContainer = new UnityContainer();
            this._providerContainer.RegisterType<ICreditCardProvider, MockCreditCardProvider>();
        }

        private static CreditCardProvider _creditCardProvider;

        public static CreditCardProvider Current
        {
            get
            {
                if (CreditCardProvider._creditCardProvider == null)
                {
                    CreditCardProvider._creditCardProvider = new CreditCardProvider();
                }
                return _creditCardProvider;
            }
        }

        public ICreditCardProvider GetCreditCardProvider()
        {
            return this._providerContainer.Resolve<ICreditCardProvider>();
        }

    }
}
