﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using IASA.Demo.BusinessModel;
using IASA.Demo.Data;
using IASA.Demo.Data.Generic;
using IASA.Demo.CreditCardProvider;

namespace IASA.Demo.BusinessService
{
    public class CustomerService : IASA.Demo.BusinessService.ICustomerService
    {
        public CustomerService()
        {
        }

        public Customer GetCustomerById(Guid customerId)
        {
            // Setup Criteria Object
            QueryCriteria criteria = new QueryCriteria();
            criteria.AddParameter("Id", customerId.ToString());

            // Call Repository to get customer
            CustomerRepository repository = new CustomerRepository();
            return repository.FindOne(criteria);
        }

        public CustomerOrderAdapter GetCustomerOrderHistory(Guid customerId)
        {
            // Setup Criteria Object
            QueryCriteria criteria = new QueryCriteria();
            criteria.AddParameter("Id", customerId.ToString());

            // Call Repository to get customer
            CustomerRepository repository = new CustomerRepository();
            Customer customer = repository.FindOne(criteria);

            // Get customer order history
            OrderRepository orderRepository = new OrderRepository();
            customer.OrderHistory = orderRepository.Find(criteria);

            return new CustomerOrderAdapter(customer);
        }

    }
}
