﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using IASA.Demo.BusinessModel;
using IASA.Demo.BusinessService;

namespace IASA.Demo.BusinessTest
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class ProcessOrderTest
    {
        public ProcessOrderTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestProcessOrder()
        {

            Customer customer = this.GetMockCustomer();
            customer.CurentOrder = this.GetMockOrder();

            IOrderService orderService = new OrderService();
            OrderPurchasedResult orderResult = orderService.ProcessOrder(customer);

            Assert.IsTrue(orderResult.IsOrderPurchasedValid);
        }

        private Customer GetMockCustomer()
        {
            Address customerAddress = new Address { StreetAddress1 = "100 Main Street", City = "East Windsor", State = "NJ", PostalCode = "08520" };

            return new Customer
            {
                Id = Guid.NewGuid(),
                Name = "Todd Snyder",
                BillToAddress = customerAddress,
                ShipToAddress = customerAddress
            };
        }

        private Order GetMockOrder()
        {
            Order order = new Order { Id = Guid.NewGuid(), OrderProcessDate = DateTime.Now, IsComplete = false };
            order.AddOrderDetail(1, new SmallProduct { Id = Guid.NewGuid(), Name = "XBox 360", Price = 399.99d });
            order.AddOrderDetail(2, new SmallProduct { Id = Guid.NewGuid(), Name = "Halo 3", Price = 69.99d });
            return order;
        }
    }
}
