﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using IASA.Demo.BusinessModel;
using IASA.Demo.Data.Generic;

namespace IASA.Demo.Data
{
    internal class CustomerDataMapper : IDataMapper<Customer, QueryCriteria>
    {

        #region IDataMapper<Customer,QueryCriteria> Members

        public bool SaveChildren
        {
            get { return false; }
        }

        public DataCommand ConstructSelectCommand(QueryCriteria identity)
        {
            DataCommand command = new DataCommand();

            foreach(Datum item in identity.Parameters)
            {
                command.AddParameter(item.Name, item.Value);
            }

            return command;
        }

        public DataCommand ConstructSelectListCommand(QueryCriteria identity)
        {
            DataCommand command = new DataCommand();

            foreach (Datum item in identity.Parameters)
            {
                command.AddParameter(item.Name, item.Value);
            }

            return command;
        }

        public DataCommand ConstructSaveCommand(Customer domainObject)
        {
            DataCommand command = new DataCommand();

            if (domainObject.BillToAddress != null)
            {
                command.AddParameter("Id", domainObject.Id.ToString());
                command.AddParameter("Name", domainObject.Name);
                command.AddParameter("BillToStreetAddress1", domainObject.BillToAddress.StreetAddress1);
                command.AddParameter("BillToStreetAddress2", domainObject.BillToAddress.StreetAddress2);
                command.AddParameter("BillToCity", domainObject.BillToAddress.City);
                command.AddParameter("BillToState", domainObject.BillToAddress.State);
                command.AddParameter("BillToPostalCode", domainObject.BillToAddress.PostalCode);
            }

            if (domainObject.ShipToAddress != null)
            {
                command.AddParameter("ShipToStreetAddress1", domainObject.ShipToAddress.StreetAddress1);
                command.AddParameter("ShipToStreetAddress2", domainObject.ShipToAddress.StreetAddress2);
                command.AddParameter("ShipToCity", domainObject.ShipToAddress.City);
                command.AddParameter("ShipToState", domainObject.ShipToAddress.State);
                command.AddParameter("ShipToPostalCode", domainObject.ShipToAddress.PostalCode);
            }

            return command;
        }

        public DataCommand ConstructDeleteCommand(Customer domainObject)
        {
            DataCommand command = new DataCommand();
            command.AddParameter("Id", domainObject.Id.ToString());

            return command;
        }

        #endregion
    }
}
