﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using IASA.Demo.BusinessModel;
using IASA.Demo.Data.Generic;

namespace IASA.Demo.Data
{
    internal class OrderDataMapper : IDataMapper<Order, QueryCriteria>
    {
        #region IDataMapper<Order,QueryCriteria> Members

        public DataCommand ConstructSelectCommand(QueryCriteria identity)
        {
            DataCommand command = new DataCommand();

            foreach (Datum item in identity.Parameters)
            {
                command.AddParameter(item.Name, item.Value);
            }

            return command;
        }

        public DataCommand ConstructSelectListCommand(QueryCriteria identity)
        {
            DataCommand command = new DataCommand();

            foreach (Datum item in identity.Parameters)
            {
                command.AddParameter(item.Name, item.Value);
            }

            return command;
        }

        public DataCommand ConstructSaveCommand(Order domainObject)
        {
            DataCommand command = new DataCommand();
            command.AddParameter("Id", domainObject.Id.ToString());
            command.AddParameter("OrderProcessDate", domainObject.OrderProcessDate.ToString());

            // Save Order Details
            foreach(OrderDetail item in domainObject.OrderDetails)
            {
                command.AddChildCommand(this.ConstructChildSaveCommand(item));
            }
            return command;
        }
        
        public DataCommand ConstructDeleteCommand(Order domainObject)
        {
            DataCommand command = new DataCommand();
            command.AddParameter("Id", domainObject.Id.ToString());

            return command;
        }

        public bool SaveChildren
        {
            get { return true; }
        }

        #endregion

        private DataCommand ConstructChildSaveCommand(OrderDetail item)
        {
            DataCommand command = new DataCommand();

            command.AddParameter("NumberOfItems", item.NumberOfItems.ToString());
            command.AddParameter("ProductId", item.Product.Id.ToString());

            return command;
        }
    }
}
