﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using IASA.Demo.BusinessModel;
using IASA.Demo.Data.Generic;

namespace IASA.Demo.Data
{
    internal class OrderMapper : IObjectMapper<Order>
    {
        #region IObjectMapper<Order> Members

        public Order Construct(DataResult dataResult)
        {
            return GetMockOrder();
        }

        public List<Order> ConstructList(DataResult dataResult)
        {
            List<Order> orderHistory = new List<Order>();
            orderHistory.Add(this.GetMockOrder());
            orderHistory.Add(this.GetMockOrder());
            orderHistory.Add(this.GetMockOrder());
            return orderHistory;
        }

        #endregion

        private Order GetMockOrder()
        {
            Order order = new Order { Id = Guid.NewGuid(), OrderProcessDate = DateTime.Now, IsComplete = true };
            order.AddOrderDetail(3, new SmallProduct { Id = Guid.NewGuid(), Name = "XBox 360", Price = 399.99d });
            order.AddOrderDetail(4, new SmallProduct { Id = Guid.NewGuid(), Name = "Halo 3", Price = 69.99d });
            return order;

        }
    }
}
