﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;

using IASA.Demo.Presentation.MVP;
using IASA.Demo.BusinessModel;
using IASA.Demo.BusinessService;
using IASA.Demo.Presentation.MVP.Test.Mocks;
using Moq;


namespace IASA.Demo.Presentation.MVP.Test
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class CustomerPresenterTest
    {
        public CustomerPresenterTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestGetCustomerById()
        {
            MockCustomerView mockView = new Mocks.MockCustomerView();
            mockView.customerId = Guid.NewGuid();
            
            var mockService = new Mock<ICustomerService>();
            mockService.Expect<Customer>(x => x.GetCustomerById(mockView.customerId)).Returns(this.GetMockCustomer());

            CustomerPresenter presenter = new CustomerPresenter(mockView, mockService.Object);
            presenter.Initialize();

            Assert.IsTrue(mockView.IsViewLoaded);
        }

        [TestMethod]
        public void TestGetInvalidCustomer()
        {
            ICustomerView mockView = new Mocks.MockCustomerView();
            mockView.customerId = Guid.NewGuid();

            var mockService = new Mock<ICustomerService>();
            mockService.Expect<Customer>(x => x.GetCustomerById(mockView.customerId)).Returns(new Customer());

            CustomerPresenter presenter = new CustomerPresenter(mockView, mockService.Object);
            presenter.Initialize();

            Assert.IsNull(mockView.customerName);
        }


        private Customer GetMockCustomer()
        {
            Address customerAddress = new Address { StreetAddress1 = "100 Main Street", City = "East Windsor", State = "NJ", PostalCode = "08520" };

            return new Customer
            {
                Id = Guid.NewGuid(),
                Name = "Todd Snyder",
                BillToAddress = customerAddress,
                ShipToAddress = customerAddress
            };
        }
    }
}
