﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using IASA.Demo.Presentation.MVP;
using IASA.Demo.BusinessModel;
using IASA.Demo.BusinessService;
using IASA.Demo.Presentation.MVP.Test.Mocks;
using Moq;

namespace IASA.Demo.Presentation.MVP.Test
{
    /// <summary>
    /// Summary description for OrderPresenterTest
    /// </summary>
    [TestClass]
    public class OrderPresenterTest
    {
        public OrderPresenterTest()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestViewOrderHistory()
        {

            MockOrderView mockView = new Mocks.MockOrderView();
            mockView.customerId = Guid.NewGuid().ToString();

            var mockService = new Mock<ICustomerService>();
            mockService.Expect<CustomerOrderAdapter>(x => x.GetCustomerOrderHistory(new Guid(mockView.customerId))).Returns(this.GetMockCustomer());

            OrderPresenter presenter = new OrderPresenter(mockView, mockService.Object);
            presenter.Initialize();

            Assert.IsTrue(mockView.IsViewLoaded);
        }

        private CustomerOrderAdapter GetMockCustomer()
        {
            Address customerAddress = new Address { StreetAddress1 = "100 Main Street", City = "East Windsor", State = "NJ", PostalCode = "08520" };

            Customer mockCustomer =  new Customer
            {
                Id = Guid.NewGuid(),
                Name = "Todd Snyder",
                BillToAddress = customerAddress,
                ShipToAddress = customerAddress
            };

            IList<Order> orderHistory = new List<Order>();
            orderHistory.Add(this.GetMockOrder());

            mockCustomer.OrderHistory = orderHistory;

            return new CustomerOrderAdapter(mockCustomer);
        }

        private Order GetMockOrder()
        {
            Order order = new Order { Id = Guid.NewGuid(), OrderProcessDate = DateTime.Now, IsComplete = false };
            order.AddOrderDetail(1, new SmallProduct { Id = Guid.NewGuid(), Name = "XBox 360", Price = 399.99d });
            order.AddOrderDetail(2, new SmallProduct { Id = Guid.NewGuid(), Name = "Halo 3", Price = 69.99d });
            return order;
        }
    }
}
