﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace IASA.Demo.Presentation.MVP
{
    public abstract class BasePresenter<TView>
    {

        public BasePresenter(TView view)
        {
            this._view = view;
            this.SubscribeToEvents();
        }

        private TView _view;

        public TView View 
        {
            get { return _view; }
        }

        public void Initialize()
        {
            this.GetModel();
            this.BindModel();
        }

        protected virtual void SubscribeToEvents()
        {

        }


        protected abstract void GetModel();
        protected abstract void BindModel();


    }
}
