﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using IASA.Demo.BusinessModel;
using IASA.Demo.BusinessService;

namespace IASA.Demo.Presentation.MVP
{
    public class CustomerPresenter : BasePresenter<ICustomerView>
    {
        private ICustomerService _businessService;

        public CustomerPresenter(ICustomerView view)
            : this(view, new CustomerService())
        {
        }

        public CustomerPresenter(ICustomerView view, ICustomerService service)  : base(view)
        {
            this._businessService = service;
        }

        private Customer _customer;
        protected override void GetModel()
        {
            this._customer = this._businessService.GetCustomerById(this.View.customerId);
        }

        protected override void BindModel()
        {
            this.View.customerId = this._customer.Id;
            this.View.customerName = this._customer.Name;
            this.View.BillToAddress = this._customer.BillToAddress;
            this.View.ShipToAddress = this._customer.ShipToAddress;
        }
    }
}
