﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using IASA.Demo.BusinessModel;
using IASA.Demo.BusinessService;

namespace IASA.Demo.Presentation.MVP
{
    public class OrderPresenter : BasePresenter<IOrderView>
    {

         private ICustomerService _businessService;

         public OrderPresenter(IOrderView view)
            : this(view, new CustomerService())
        {
        }

         public OrderPresenter(IOrderView view, ICustomerService service)
            : base(view)
        {
            this._businessService = service;
        }

        private CustomerOrderAdapter _customer;
        protected override void GetModel()
        {
            this._customer = this._businessService.GetCustomerOrderHistory(new Guid(this.View.customerId));
        }

        protected override void BindModel()
        {
            this.View.customerId = this._customer.CustomerId;
            this.View.customerName = this._customer.CustomerName;
            this.View.OrderHistory = this._customer.OrderHistory;
        }
    }
}
