﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

using IASA.Demo.BusinessModel;
using IASA.Demo.BusinessService;

namespace IASA.Demo.Web.MVC.Controllers
{
    public class CustomerController : Controller
    {
        public void ViewCustomer(string customerId)
        {
            Customer customer = new CustomerService().GetCustomerById(new Guid(customerId));
            RenderView("CustomerView", customer);
        }

        public void ViewCustomerOrderHistory(string customerId)
        {
            CustomerOrderAdapter customerAdapter = new CustomerService().GetCustomerOrderHistory(new Guid(customerId));
            RenderView("CustomerOrderHistory", customerAdapter);
        }

        public void ViewCheckOut(string customerId)
        {
            Customer customer = new CustomerService().GetCustomerById(new Guid(customerId));
            RenderView("ViewCheckOut", customer);
        }

        public void ProcessOrder(string customerId, string productName, int numberOfItems, double amount)
        {
            Customer customer = new CustomerService().GetCustomerById(Guid.NewGuid());

            Order order = new Order { Id = Guid.NewGuid(), OrderProcessDate = DateTime.Now, IsComplete = false };
            order.AddOrderDetail(numberOfItems, new SmallProduct { Id = Guid.NewGuid(), Name = productName, Price = amount });
            customer.CurentOrder = order;

            IOrderService orderService = new OrderService();
            OrderPurchasedResult orderResult = orderService.ProcessOrder(customer);

            RenderView("ViewOrderPurchased", orderResult);
        }


    }
}
